# code.py
# simple encryption program 

# Import the Tk gui-making features
# from Tkinter import *

# if you are using Python 2, uncomment the previous line
# and comment ou the following line
from tkinter import *
import time

# don't change punctuation or space
punct = " ()!$^&*-_=+[{}]#'@;:?/.,<>"
punct = punct + '"'  

# make an array to hold printable characters
printable = []
a = ord('a') 
z = ord('z') + 1
A = ord('A') 
Z = ord('Z') + 1
zero = ord('0')
nine = ord('9') + 1

for i in range (A, Z):
    printable.append(chr(i))
for i in range (a, z):
    printable.append(chr(i))
for i in range (zero, nine):
    printable.append(chr(i))

p_length = len(printable)

# function definition for the buttons
def decode():
    submit("decode")

def encode():
    submit("encode")

def submit(action):
    message = ""
    
    #  process the message
    msg = in_ent.get()
    key = key_ent.get()

    # check there is a message
    if msg == "":
        message = "You haven't entered a message"
        display(message)
        return

    # check that the key is a number
    try:
        key = int(key)
    except ValueError:
        message = "Please enter a numerical key."
        display(message)
        return

    # check the key is between -26 and 26
    if key < -26 or key > 26: 
       message = "Please use a number between -26 and 26"
       display(message)
       return
    
    # don't alter punctuation
    for i in range (len(msg)):
        temp = msg[i]
        if temp in punct:
            message = message + temp
            continue

        # find the position of the current letter
        ind = printable.index(temp)
        
        if action =="decode":
            pos = ind - key
        else:
            pos = ind + key

        # check if we have gone over either end of the array
        if pos > p_length:
            pos = pos - p_length
        if pos < 0:
            pos = p_length + pos 
        
        # add the decoded letter to message
        message = message + (printable[pos])
            
    # clear text entry box and print message
    in_ent.delete(0, END)
    loop_display(message)


def display(message):
    # clear the display box and print the message
    txt.delete(0.0, END)
    txt.insert(0.0, message)

def loop_display(message):
    temp = ""
    for i in range(len(message)-1):
        if message[i] in punct:
            temp = temp + message[i]
            continue
        for j in range (len(printable)):
            temp_out = temp + printable[j]
            txt.delete(0.0, END)
            txt.insert(0.0, temp_out)
            time.sleep(0.001)
            root.update()
            if printable[j] == message[i]:
                temp = temp + message[i]
                continue
    txt.delete(0.0, END)
    txt.insert(0.0, message)
            
                


# create the "root" window - within which 
# everything else will be built.
root = Tk()
root.title("Secret Code")
root.geometry("400x250")
app = Frame(root)
app.grid()

# setting up the GUI
# top label
lbl = Label(app, text = "Welcome to Secret Code!")
lbl.grid(row = 0, column = 1,  pady = 5, sticky = W)

# labels and text entry
in_lbl = Label(app, text = "Secret Message:")
in_lbl.grid(row = 1, column = 0, pady = 5)
in_ent = Entry(app, width = 30)
in_ent.grid(row = 1, column = 1, pady = 5)

key_lbl = Label(app, text = "Input a key\n (-26 to 26):")
key_lbl.grid(row = 2, column = 0, pady = 5)
key_ent = Entry(app, width = 2)
key_ent.grid(row = 2, column = 1, pady = 5, sticky = W)

# make a button
bttn = Button(app, text = "Encode!")
bttn["command"] = encode
bttn.grid(row = 3, column = 0, pady = 5)  

# make a button
bttn = Button(app, text = "Decode!")
bttn["command"] = decode
bttn.grid(row = 3, column = 1, pady = 5)  

# make a text box
msg_lbl = Label(app, text = "Code:")
msg_lbl.grid(row = 5, column = 0, pady = 5)
txt = Text(app, width = 30, height = 3, wrap = WORD)
txt.grid(row = 5, column = 1, pady = 5)

# Start the main-loop (like in a game).
root.mainloop()
